<?php
/*
	만든이 : 팥알 ( http://pat.im )
	마지막으로 고친 때 : 2014.8.20
	
	[##_blog_QR_code_##] : 블로그 주소의 QR 부호 치환자
	[##_post_QR_code_##] : 글 주소의 QR 부호 치환자
	[##_custom_QR_code_##] : 지정한 주소의 QR 부호 치환자
	
	위젯 설정으로 옆막대(사이드바)에 QR 부호를 넣을 수 있습니다.
*/


require_once('phpqrcode/qrlib.php');

function QR_code_content($url, $size, $ECC_level, $border_type, $border_width, $border_color){
	
	global $configVal, $pluginURL;
	$data = Setting::fetchConfigVal($configVal);

	//set it to writable location, a place for temp generated PNG files
	$PNG_TEMP_DIR = dirname(__FILE__).DIRECTORY_SEPARATOR.'cache'.DIRECTORY_SEPARATOR;    
	
	//html PNG location prefix
	$PNG_WEB_DIR = $pluginURL.'/cache/';

	if(!file_exists($PNG_TEMP_DIR)) mkdir($PNG_TEMP_DIR);

	$filename = $PNG_TEMP_DIR.md5($url.'|'.$ECC_level.'|'.$size).'.png';

	QRcode::png($url, $filename, $ECC_level, $size, 2);
	
	$content = '';
	if(isset($data['javascript']) && $data['javascript']) $content .= '<script type="text/javascript"><!--'.CRLF.'document.write(\'';	
	$content .= isset($data['link']) && $data['link'] ? '<a href="'.$url.'">' : '';
	
	$style = '';
	if($border_type) {
		$style = 'border:'.$border_width.'px '.$border_type;
		if($border_color) $style .= ' #'.$border_color;
		$style .= ';';
	}

	$content .= '<img src="'.$PNG_WEB_DIR.basename($filename).'" alt="QR code" style="'.$style.'"/>';
	$content .= $data['link'] ? '</a>' : '';
	if($data['javascript']) $content .= '\');'.CRLF.'//-->'.CRLF.'</script>';
	
	return $content;
}

function show_post_QR_code_onTag($target) {		// 치환자로 글 주소 QR 부호 나타내기
	
	global $configVal, $pluginURL, $blog, $entry, $defaultURL;
	$data = Setting::fetchConfigVal($configVal);
	
	if($entry['id']) $post_url = $defaultURL.'/'.($blog['useSloganOnPost'] && $data['post_url']==1 ? 'entry/'.URL::encode($entry['slogan'], $useEncodeURL) : $entry['id']);		// 글 주소
	else $post_url = (isset( $_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on' ? 'https://' : 'http://').$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	
	$matrixPointsize = isset($data['size']) ? $data['size'] : 4;
	$errorCorrectionLevel = isset($data['ECC_level']) ? $data['ECC_level'] : 'L';
	$border_type = isset($data['border_type']) && $data['border_type'] != 'none' ? $data['border_type'] : '';
	$border_width = isset($data['border_width']) ? $data['border_width'] : 0;
	$border_color = isset($data['border_color']) ? $data['border_color'] : '';
	
	$content = '';
	if(!empty($data['post_header'])) $content .= $data['post_header'];
	$content .= QR_code_content($post_url, $matrixPointsize, $errorCorrectionLevel, $border_type, $border_width, $border_color);
	if(!empty($data['post_footer'])) $content .= $data['post_footer'];

	return $content;
}

function show_blog_QR_code_onTag($target) {		// 치환자로 블로그 주소 QR 부호 나타내기
	
	global $configVal, $pluginURL, $defaultURL;
	$data = Setting::fetchConfigVal($configVal);
	
	$matrixPointsize = isset($data['size']) ? $data['size'] : 4;
	$errorCorrectionLevel = isset($data['ECC_level']) ? $data['ECC_level'] : 'L';
	$border_type = $data['border_type'] && $data['border_type'] != 'none' ? $data['border_type'] : '';
	$border_width = $data['border_width'];
	$border_color = $data['border_color'];

	$content = $data['blog_header'];
	$content .= QR_code_content($defaultURL, $matrixPointsize, $errorCorrectionLevel, $border_type, $border_width, $boder_color);
	$content .= $data['blog_footer'];

	return $content;
}

function show_custom_QR_code_onTag($target) {		// 치환자로 따로 넣은 주소 QR 부호 나타내기
	
	global $configVal, $pluginURL, $defaultURL;
	$data = Setting::fetchConfigVal($configVal);
	
	$matrixPointsize = isset($data['size']) ? $data['size'] : 4;
	$errorCorrectionLevel = isset($data['ECC_level']) ? $data['ECC_level'] : 'L';
	$border_type = isset($data['border_type']) && $data['border_type'] != 'none' ? $data['border_type'] : '';
	$border_width = isset($data['border_width']) ? $data['border_width'] : 0;
	$border_color = isset($data['border_color']) ? $data['border_color'] : '';

	$content = $data['custom_header'];
	$content .= QR_code_content($defaultURL, $matrixPointSize, $errorCorrectionLevel, $border_type, $border_width, $border_color);
	$content .= $data['custom_footer'];

	return $content;
}

function show_QRcode_onSidebar($parameter) {		// 옆막대에 QR 부호 나타내기
	global $configVal , $entry, $defaultURL;
	$data = Setting::fetchConfigVal($configVal);

	// 본문에 이 확장기능이 쓰는 치환자가 들어 있어서 생기는 텍스트큐브의 오류를 막는다.
	if(strpos($entry['content'],'[##_blog_QR_code_##]')) $entry['content'] = str_replace('[##_blog_QR_code_##]','',$entry['content']);
	if(strpos($entry['content'],'[##_post_QR_code_##]')) $entry['content'] = str_replace('[##_post_QR_code_##]','',$entry['content']);
	if(strpos($entry['content'],'[##_custom_QR_code_##]')) $entry['content'] = str_replace('[##_custom_QR_code_##]','',$entry['content']);

	if($data['sidebar_url']=='blog' || $data['sidebar_url']=='') $url = $defaultURL;
	else if($data['sidebar_url']=='post') {
		if($entry['id']) $url = $defaultURL.'/'.($blog['useSloganOnPost'] && $data['post_url']==1 ? 'entry/'.URL::encode($entry['slogan'], $useEncodeURL) : $entry['id']);		// 글 주소
		else $url = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	} else if($data['sidebar_url']=='custom') $url = $data['custom_url'];
	
	$matrixPointSize = isset($data['sidebar_size']) ? $data['sidebar_size'] : 4;
	$errorCorrectionLevel = isset($data['sidebar_ECC_level']) ? $data['sidebar_ECC_level'] : 'L';
	$border_type = isset($data['sidebar_border_type']) && $data['sidebar_border_type'] != 'none' ? $data['sidebar_border_type'] : '';
	$border_width = isset($data['sidebar_border_width']) ? $data['sidebar_border_width'] : 0;
	$border_color = isset($data['sidebar_border_color']) ? $data['sidebar_border_color'] : '';

	$content = '';
	if(empty($data['sidebar_header'])) $content .= $data['sidebar_header'];
	if(isset($data['sidebar_align']) && $data['sidebar_align'] != 'none') {
		switch($data['sidebar_align']) {
			case 'center' :
				$align = 'center';
				break;
			case 'left' :
				$align = 'left';
				break;
			case 'right' :
				$align = 'center';
				break;
			default :
				$align = 'center';
		}
		$content .= '<div style="text-align:'.$align.';">';
	}
	$content .= QR_code_content($url, $matrixPointSize, $errorCorrectionLevel, $border_type, $border_width, $border_color);
	if(isset($data['sidebar_align']) && $data['sidebar_align'] != 'none') $content .= '</div>';
	if(empty($data['sidebar_footer'])) $content .= $data['sidebar_footer'];

	return $content;
}



function QR_config($plugin) {
	$manifest = '
<config dataValHandler = "QR_DataSet">
	<fieldset legend="공통 설정">
		<field title="따로 넣을 주소 :" name="custom_url" type="text" size="25" value="http://" titledirection="" />
		<field title="주소 걸기(링크) :" type="checkbox" name="link">
			<op name="link" value="1"></op>
		</field>
		<field title="자바스크립트로 그림 넣기 :" type="checkbox" name="javascript">
			<op name="javascript" value="1"></op>
			<caption><![CDATA[※ 자바스크립트로 그림을 넣으면 페이스북 미리보기 그림에 QR 부호가 들어가는 것을 막을 수 있습니다.]]>
			</caption>
		</field>
	</fieldset>

	<fieldset legend="치환자로 넣기">
		<field title="크기 :" name="size" type="radio">
			<op value="1"><![CDATA[1]]></op>
			<op value="2"><![CDATA[2]]></op>
			<op value="3"><![CDATA[3]]></op>
			<op value="4" checked="checked"><![CDATA[4]]></op>
			<op value="5"><![CDATA[5]]></op>
			<op value="6"><![CDATA[6]]></op>
			<op value="7"><![CDATA[7]]></op>
			<op value="8"><![CDATA[8]]></op>
			<op value="9"><![CDATA[9]]></op>
			<op value="10"><![CDATA[10]]></op>
		</field>
		<field title="오류 보정 수준 :" name="ECC_level" type="radio">
			<op value="L" checked="checked"><![CDATA[L - 가장 낮음]]></op>
			<op value="M"><![CDATA[M]]></op>
			<op value="Q"><![CDATA[Q]]></op>
			<op value="H"><![CDATA[H - 가장 높음]]></op>
		</field>
		<field title="테두리 모양 :" name="border_type" type="radio">
			<op value="none" checked="checked"><![CDATA[없음]]></op>
			<op value="solid"><![CDATA[실선]]></op>
			<op value="dotted"><![CDATA[점선]]></op>
			<op value="dashed"><![CDATA[긴 점선]]></op>
		</field>		
		<field title="테두리 두께(px) :" name="border_width" type="text" size="3"/>
		<field title="테두리 빛깔(RGB) : #" name="sidebar_border_color" type="text" size="9">
			<caption><![CDATA[※ [##_blog_QR_code_##]에는 블로그 주소 QR 부호가 들어갑니다.<br />
			※ [##_post_QR_code_##]에는 글 주소 QR 부호가 들어갑니다.<br />
			※ [##_custom_QR_code_##]에는 따로 넣은 주소 QR 부호가 들어갑니다.]]></caption>
		</field>
		<field title="블로그 주소 QR 부호 머리글 :" name="blog_header" type="textarea" rows="3" cols="57"><![CDATA[<div class="blog_QR_code">]]></field>
		<field title="블로그 주소 QR 부호 꼬리글 :" name="blog_footer" type="textarea" rows="2" cols="57"><![CDATA[</div>]]></field>
		<field title="글 주소 QR 부호 머리글 :" name="post_header" type="textarea" rows="3" cols="57"><![CDATA[<div class="post_QR_code">]]></field>
		<field title="글 주소 QR 부호 꼬리글 :" name="post_footer" type="textarea" rows="2" cols="57"><![CDATA[</div>]]></field>
		<field title="따로 넣은 주소 QR 부호 머리글 :" name="custom_header" type="textarea" rows="3" cols="57"><![CDATA[<div class="custom_QR_code">]]></field>
		<field title="따로 넣은 주소 QR 부호 꼬리글 :" name="custom_footer" type="textarea" rows="2" cols="57"><![CDATA[</div>]]></field>
	</fieldset>

	<fieldset legend="옆막대에 넣기">
		<field title="넣을 주소 :" name="sidebar_url" type="radio">
			<op value="blog" checked="checked"><![CDATA[블로그 주소]]></op>
			<op value="post"><![CDATA[글 주소]]></op>
			<op value="custom"><![CDATA[따로 넣은 주소]]></op>
		</field>
		<field title="크기 :" name="sidebar_size" type="radio">
			<op value="1"><![CDATA[1]]></op>
			<op value="2"><![CDATA[2]]></op>
			<op value="3"><![CDATA[3]]></op>
			<op value="4" checked="checked"><![CDATA[4]]></op>
			<op value="5"><![CDATA[5]]></op>
			<op value="6"><![CDATA[6]]></op>
			<op value="7"><![CDATA[7]]></op>
			<op value="8"><![CDATA[8]]></op>
			<op value="9"><![CDATA[9]]></op>
			<op value="10"><![CDATA[10]]></op>
		</field>
		<field title="정렬 :" name="sidebar_align" type="radio">
			<op value="none"><![CDATA[정렬하지 않음]]></op>
			<op value="left"><![CDATA[왼쪽]]></op>
			<op value="center" checked="checked"><![CDATA[가운데]]></op>
			<op value="right"><![CDATA[오른쪽]]></op>			
		</field>
		<field title="오류 보정 수준 :" name="sidebar_ECC_level" type="radio">
			<op value="L" checked="checked"><![CDATA[L - 가장 낮음]]></op>
			<op value="M"><![CDATA[M]]></op>
			<op value="Q"><![CDATA[Q]]></op>
			<op value="H"><![CDATA[H - 가장 높음]]></op>
		</field>
		<field title="테두리 모양 :" name="sidebar_border_type" type="radio">
			<op value="none" checked="checked"><![CDATA[없음]]></op>
			<op value="solid"><![CDATA[실선]]></op>
			<op value="dotted"><![CDATA[점선]]></op>
			<op value="dashed"><![CDATA[긴 점선]]></op>
		</field>
		<field title="테두리 두께(px) :" name="sidebar_border_width" type="text" size="3" />
		<field title="테두리 빛깔(RGB) : #" name="sbar_border_color" type="text" size="8" />
		<field title="머리글 :" name="sidebar_header" type="textarea" rows="3" cols="55"><![CDATA[<div class="sidebar_QR_code"><h3>블로그 QR 부호</h3>]]></field>
		<field title="꼬리글 :" name="sidebar_footer" type="textarea" rows="2" cols="55"><![CDATA[</div>]]></field>
	</fieldset>
</config>';

	return $manifest;
}


function QR_DataSet($data){
	$cfg = Setting::fetchConfigVal($data);
	return true;
}

?>